const Select = (parent) => {
  const div = document.createElement('div')
  div.classList.add('zhstat-select')
  parent.append(div)
  
  const label = document.createElement('label')
  label.setAttribute('for', 'standard-select')
  div.append(label)
    
  const select = document.createElement('select')
  select.setAttribute('id', 'standard-select')
  div.append(select)

  const dropdown = document.createElement('div')
  dropdown.classList.add('dropdown')
  div.append(dropdown)

  const iconAfter = Icon(div, 'angleDropDown')
  iconAfter.classList.add('icon-after')
  div.classList.add('icon-after')
  let open = false
  const close = () => {
    open = false
    div.classList.toggle('open', open)
    label.classList.toggle('focus', open)
  }

  select.onblur = event => {
    event.preventDefault()
    event.stopPropagation()
    setTimeout(() => {
      open = false
      div.classList.toggle('open', open)
      label.classList.toggle('focus', open)
    }, 200)
  }
  select.onfocus = _ => {
    setTimeout(() => {
      open = true
      div.classList.toggle('open', open)
      label.classList.toggle('focus', open)
    }, 200)
  }


  let clearable = null
  let getFunction = null
  let data = null
  const setFunction = value => {
    data = value
    select.value = value
    label.innerHTML = value || '&nbsp;'
    div.classList.toggle('clearable', clearable && value !== null)
    dropdown.childNodes.forEach(option => {
      option.classList.toggle('selected', option.innerHTML === data)
    })
    if (getFunction && typeof getFunction === 'function') {
      getFunction(value)
    }
  }

  select.onchange = event => {
    setFunction(event.target.value)
  }

  const prop = (name, p) => {
    switch (name) {
      case 'clearable':
        if (p) {
          clearable = Icon(parent, 'clear')
          clearable.classList.add('toggle')
          div.append(clearable)
          clearable.onclick = event => {
            setFunction(null)
            close()
          }
          div.classList.toggle('clearable', select.value !== null)
        } else {
          if (clearable) {
            clearable.remove()
          }
        }
        break;

      case 'set':
        setFunction(p)
        break;

      case 'get':
        getFunction = p
        break;

      case 'set-options':
        select.innerHTML = ''
        for (const o of p) {
          const option = document.createElement('option')
          option.value = o
          option.innerHTML = o
          select.append(option)
        }

        dropdown.innerHTML = ''
        for (const o of p) {
          const option = document.createElement('div')
          option.innerHTML = o
          option.classList.toggle('selected', o === data)
          option.onclick = event => {
            event.preventDefault()
            setFunction(o)
          }
          dropdown.append(option)
        }
        break;

      case 'icon-after':
        const iconAfter = Icon(parent, p)
        iconAfter.classList.add('icon-after')
        div.classList.add('icon-after')
        div.append(iconAfter)
        break;

      case 'icon-before':
        const iconBefore = Icon(parent, p)
        iconBefore.classList.add('icon-before')
        div.classList.add('icon-before')
        div.append(iconBefore)
        break;
    
      case 'readonly':
        select.setAttribute('readonly', p)
        break;
      default:
        break;
    }

    return { prop }
  }
  return { prop }
}

