const Data = function () {
  const callbacks = []
  const data = {
    value: null
  }

  return new Proxy(data, {
    set: (target, key, value) => {
      if (key === 'callback') {
        callbacks.push(value)
      } else {
        target[key] = value
        for(const callback of callbacks) {
          callback(value)
        }
      }
      return true
    },
    get: (target, key) => {
      return target[key]
    }
  })
}
