const Input = ({ htl, value = "" } = {}) => {
  function set(node, value) {
    node.value = value;
    node.dispatchEvent(new Event("input", { bubbles: true })); // Native events bubble, so we should too
  }

  let node = null;
  const input = () => htl.html.fragment`<input oninput=${(ev) => set(node, ev.target.value)} value="${value}"></input>`;
  const clearable = () => htl.html.fragment`<svg onclick=${() => set(node, '')} width="24" height="24" fill="currentColor" fill-rule="evenodd" viewBox="0 0 24 24"><path d="M12 1C5.926 1 1 5.926 1 12C1 18.074 5.926 23 12 23C18.074 23 23 18.074 23 12C23 5.926 18.074 1 12 1ZM17.25 15.75L15.75 17.25L12 13.5L8.25 17.25L6.75 15.75L10.5 12L6.75 8.25L8.25 6.75L12 10.5L15.75 6.75L17.25 8.25L13.5 12L17.25 15.75Z" /></svg>`

  node = htl.html`<div class="zhstat-input">${input()}${clearable()}</div>`;

  // Update the display whenever the value changes
  Object.defineProperty(node, "value", {
    get() {
      return value;
    },
    set(v) {
      value = v;
    }
  });
  // Set the initial value
  node.value = value;

  return node;
}

export {
  Input
}